searchData={"content_type":"text/markdown","items":[{"doc":"Small tool to automate mix project creation specifically for testing.","ref":"MixTester.html","title":"MixTester","type":"module"},{"doc":"Changes Elixir AST of file","ref":"MixTester.html#at_ast/3","title":"MixTester.at_ast/3","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> MixTester.at_ast(project, \"lib/example.ex\", fn ast ->\n    ...>   Macro.prewalk(ast, fn\n    ...>     :world -> :not_the_world_mhahaha\n    ...>     other -> other\n    ...>   end)\n    ...> end)\n    iex> {_, 2} = MixTester.mix_cmd(project, \"test\")","ref":"MixTester.html#at_ast/3-example","title":"Example: - MixTester.at_ast/3","type":"function"},{"doc":"Deletes project","ref":"MixTester.html#cleanup/1","title":"MixTester.cleanup/1","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> MixTester.cleanup(project)\n    iex> MixTester.exists?(project, \"mix.exs\")\n    false","ref":"MixTester.html#cleanup/1-example","title":"Example: - MixTester.cleanup/1","type":"function"},{"doc":"Removes all existing projects","ref":"MixTester.html#cleanup_all/0","title":"MixTester.cleanup_all/0","type":"function"},{"doc":"iex> project1 = MixTester.setup(name: :example)\n    iex> project2 = MixTester.setup(name: :example)\n    iex> MixTester.cleanup_all()\n    iex> MixTester.exists?(project1, \"mix.exs\")\n    false\n    iex> MixTester.exists?(project2, \"mix.exs\")\n    false","ref":"MixTester.html#cleanup_all/0-example","title":"Example: - MixTester.cleanup_all/0","type":"function"},{"doc":"Executes command in project root","ref":"MixTester.html#cmd/4","title":"MixTester.cmd/4","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> {ls, 0} = MixTester.cmd(project, \"ls\", [\"-l\", \"-a\"])\n    iex> ls =~ \"mix.exs\"","ref":"MixTester.html#cmd/4-example","title":"Example: - MixTester.cmd/4","type":"function"},{"doc":"Checks if path exists in the project","ref":"MixTester.html#exists?/2","title":"MixTester.exists?/2","type":"function"},{"doc":"iex> project = MixTester.setup()\n    iex> MixTester.exists?(project, \"mix.exs\")\n    true\n    iex> MixTester.exists?(project, \"this_file_does_not_exist_actually.txt\")\n    false","ref":"MixTester.html#exists?/2-example","title":"Example: - MixTester.exists?/2","type":"function"},{"doc":"Expands path from relative path of the project","ref":"MixTester.html#expand/2","title":"MixTester.expand/2","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> MixTester.expand(project, \"mix.exs\")\n    \"/tmp/mix_tester/123/example/mix.exs\"","ref":"MixTester.html#expand/2-example","title":"Example: - MixTester.expand/2","type":"function"},{"doc":"Executes mix command in project root","ref":"MixTester.html#mix_cmd/4","title":"MixTester.mix_cmd/4","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> {_, 0} = MixTester.mix_cmd(project, \"compile\")","ref":"MixTester.html#mix_cmd/4-example","title":"Example: - MixTester.mix_cmd/4","type":"function"},{"doc":"Executes mix test in the project. Returns `true` or `false`","ref":"MixTester.html#mix_test/3","title":"MixTester.mix_test/3","type":"macro"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> true = MixTester.mix_test(project)","ref":"MixTester.html#mix_test/3-example","title":"Example - MixTester.mix_test/3","type":"macro"},{"doc":"Create a directory for specified file.","ref":"MixTester.html#mkdir_p/2","title":"MixTester.mkdir_p/2","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> MixTester.mkdir_p(project, \"priv/static/file\")\n    iex> MixTester.sh(project, \"ls priv/\")\n    {\"static\\n\", 0}","ref":"MixTester.html#mkdir_p/2-example","title":"Example: - MixTester.mkdir_p/2","type":"function"},{"doc":"Reads the existing file from project","ref":"MixTester.html#read/2","title":"MixTester.read/2","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> \"defmodule Example\" <> _ = MixTester.read(project, \"lib/example.ex\")","ref":"MixTester.html#read/2-example","title":"Example: - MixTester.read/2","type":"function"},{"doc":"Sets up the mix project for testing","ref":"MixTester.html#setup/1","title":"MixTester.setup/1","type":"function"},{"doc":"iex> deps = [pathex: \"~> 2.5\"]\n    iex> project = MixTester.setup(name: :example, project: [deps: deps])\n    iex> \"defmodule Example\" <> _ = MixTester.read(project, \"lib/example.ex\")","ref":"MixTester.html#setup/1-example","title":"Example: - MixTester.setup/1","type":"function"},{"doc":"Executes shell command in the project","ref":"MixTester.html#sh/3","title":"MixTester.sh/3","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> {ls, 0} = MixTester.sh(project, \"ls -la\")\n    iex> ls =~ \"mix.exs\"","ref":"MixTester.html#sh/3-example","title":"Example: - MixTester.sh/3","type":"function"},{"doc":"Writes a file in the project","ref":"MixTester.html#write/4","title":"MixTester.write/4","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> MixTester.write(project, \"priv/something.txt\", \"Hello!\")\n    iex> MixTester.read(project, \"priv/something.txt\")\n    \"Hello!\"","ref":"MixTester.html#write/4-example","title":"Example: - MixTester.write/4","type":"function"},{"doc":"Writes an AST in the file","ref":"MixTester.html#write_ast/4","title":"MixTester.write_ast/4","type":"function"},{"doc":"iex> project = MixTester.setup(name: :example)\n    iex> MixTester.write_ast(project, \"test/test_helper.exs\", quote do: ExUnit.start(max_failures: 1))\n    iex> {_, 0} = MixTester.mix_cmd(project, \"test\")\n    iex> MixTester.read(project, \"test/test_helper.exs\")\n    \"ExUnit.start(max_failures: 1)\"","ref":"MixTester.html#write_ast/4-example","title":"Example: - MixTester.write_ast/4","type":"function"},{"doc":"","ref":"MixTester.html#t:application_env/0","title":"MixTester.application_env/0","type":"type"},{"doc":"Accepts same options as `System.cmd` function","ref":"MixTester.html#t:command_option/0","title":"MixTester.command_option/0","type":"type"},{"doc":"Output and exit code returned by executed command","ref":"MixTester.html#t:command_result/0","title":"MixTester.command_result/0","type":"type"},{"doc":"- `:name` (string) — Name of the mix project (doesn't have to be unique)\n- `:new` (string) — String of options for `mix new name`\n- `:application_env` (application_env) — A configuration for the project\n- `:system_env` (env maps) — System env configuration\n- `:project` - A kv to override what's written in `mix.exs`'s `project` function\n- `:application` - A kv to override what's written in `mix.exs`'s `application` function","ref":"MixTester.html#t:setup_option/0","title":"MixTester.setup_option/0","type":"type"},{"doc":"Module with helpers for working with AST","ref":"MixTester.AST.html","title":"MixTester.AST","type":"module"},{"doc":"Traverses AST looking for specific pattern","ref":"MixTester.AST.html#find/3","title":"MixTester.AST.find/3","type":"function"},{"doc":"Structure which contains path to project root directory\nand a name of the project","ref":"MixTester.Project.html","title":"MixTester.Project","type":"module"},{"doc":"","ref":"MixTester.Project.html#t:t/0","title":"MixTester.Project.t/0","type":"type"},{"doc":"# MixTester\n\nTiny project for testing mix tasks and anything related to project management and code generation tooling","ref":"readme.html","title":"MixTester","type":"extras"},{"doc":"* Real mix project management experience with `new` flags and other stuff\n* Application env configuration\n* Dependency list and other mix.exs configuration\n* Handy and simple helpers for common commands\n* ExUnit's async friendly","ref":"readme.html#features","title":"Features - MixTester","type":"extras"},{"doc":"```elixir\ndefmodule AwesomeTask do\n  use ExUnit.Case, async: true\n\n  setup do\n    deps = [ {:awesome_task, path: File.cwd!()} ]\n    configuration = %{{:awesome_task, :year} => 2007}\n\n    # Creates project with `mix new my_project --sup`\n    # Which has `awesome_task` as a dependency\n    # And configuration where `config.exs` has\n    project =\n      MixTester.setup(\n        name: \"my_project\",\n        new: \"--sup\",\n        application_env: %{\n          \"config\" => configuration\n        },\n        project: [\n          deps: deps\n        ]\n      )\n\n    # Creates the test file\n    MixTester.write_ast(project, \"test/my_project_test.exs\", quote do\n      defmodule MyProjectTest do\n        use ExUnit.Case, async: true\n\n        test \"Just works\" do\n          assert 2007 == AwesomeModule.what_year_is_today()\n        end\n      end\n    end)\n\n    # Cleanup the tmp dir\n    on_exit(fn -> MixTester.cleanup(project) end)\n    {:ok, project: project}\n  end\n\n  test \"My awesome task\", %{project: project} do\n    # Run the task we are testing\n    assert {_, 0} = MixTester.mix_cmd(project, \"awesome\")\n\n    # Run the test written above and check if it's run successfully\n    assert {_, 0} = MixTester.mix_cmd(project, \"test\")\n  end\nend\n```\n\nCheck out the documentation for more practical use cases:\nhttps://hexdocs.pm/mix_tester","ref":"readme.html#usage","title":"Usage - MixTester","type":"extras"},{"doc":"```elixir\ndef deps do\n  [\n    {:mix_tester, \"~> 1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - MixTester","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* Removes `Sourceror` dependency","ref":"changelog.html#1-1-1","title":"1.1.1 - Changelog","type":"extras"},{"doc":"* Adds `mix_test` command with handy output\n* Adds `system_env` configuration for project setup","ref":"changelog.html#1-1-0","title":"1.1.0 - Changelog","type":"extras"},{"doc":"Initial release","ref":"changelog.html#1-0-0","title":"1.0.0 - Changelog","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}